#include "admutils.h" 
#include "gammas.h" 

struct xparm {
  SNP  *cupt1   ;
  SNP  *cupt2   ;
  Indiv **indm   ; 
  int numindivs ;
  double xflat ; 
} ;

struct xparm2 {
 double *xdis ;
 double *pa ;
 double *lama  ; 
 int n ;
 double xp1 ;  
 double xp2 ;
} ;

void
tlest(Indiv *indx, SNP **snpmarkers, int *ethnic, int fc, int lc,
   double *theta, double *lambda)  ;


int nextmarkx (int start, int end, int inc, int *ee)  ;

void
genaa(int a, int *aa, int numstates)  ;

void
genab(double dl, double ttheta, int a, int b, 
 int *aa, int *bb, int numstates) ;

void psim1 (double dl, double theta, int a, int b, 
   double *uu, int *kpoiss) ;

void psim2 (double dl, double theta, int a, int b, 
   double *uu, int *kpoiss, int numstates) ;

void setestdis(SNP **snpm, int nsps) ;
void setgpsum(SNP **snpm, int nsps) ;
void cleargpsum(SNP **snpm, int nsps) ;

int 
loadpdis(SNP **slist, double *priordis, double *xdis, 
   SNP **snpm,  int lo,  int hi)  ;

void clearestdis(SNP **snpm, int nsps) ;
void reestld(SNP **snpm, int nsnps, Indiv **indm, int numind, double xflat) ;
void reestdis(SNP **snpm, int nsps, Indiv **indm, int numind, double xflat) ;
void estflat (double *flat, SNP **snpm, int nsnps)  ;
double
dodis(SNP *cupt1, SNP *cupt2, Indiv **indm, int numind, double xflat)  ;
double xldis(double x, void *xdata)   ;
double xldis2(double x, void *xdata)   ;
double 
ldis(SNP *cupt1, SNP *cupt2, Indiv **indm, int numind, double xflat, double dis)  ;
void fixgpos(SNP **snpm, SNP *cupt, double dis) ;
